module KR580VM80ALite
(
    input               clock,
    input               reset_n,
    input               ce,
    output      [15:0]  address,
    input       [ 7:0]  in,
    output reg  [ 7:0]  out,
    output reg          we
);

assign address = sw ? cp : pc;

// ----------------------------------------------
reg [15:0]  pc;
reg [15:0]  bc, de, hl, sp;
reg [ 7:0]  a, psw;
// ----------------------------------------------
reg         sw;     // =1 Адрес указывает на CP, иначе =0 PC
reg [15:0]  cp;     // Адрес для считывания данных из памяти
reg [ 7:0]  opcode; // Сохраненный опкод
reg [ 4:0]  t;      // Исполняемый такт опкода [0..31]
// ----------------------------------------------
wire [15:0] pcn = pc + 1;
// ----------------------------------------------

always @(posedge clock)
if (reset_n == 0) begin
    t  <= 0;        // Установить чтение кода на начало
    sw <= 0;        // Позиционировать память к PC
    pc <= 16'hF800; // Указатель на программу "Монитор"
end
else if (ce) begin

    // Счетчик микрооперации
    t <= t + 1;

    // Запись опкода на первом такте выполнения инструкции
    if (t == 0) begin opcode <= in; pc <= pcn; end

end

endmodule
